//-----------------------------------------------------------------------------
// Script.js
// 
// Javascript file for rendering a menu bar.
//-----------------------------------------------------------------------------

//---------------------------------------------------------------------
// Declare varaibles , checks for IE and Netscape browsers
//---------------------------------------------------------------------
var onceDone = false;
var menubarFromTop;
var menu, menuL, menuLink, subMenu, subMenuLink, menuStyle;
var ddSwitch = 0;
lengthArray = new Array();	

//-----------------------------------------------------------------------------
//
// @NAME
//	isBrowser
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function isBrowser(b,v) 
	{
	browserOk = false;
	versionOk = false;
	browserOk = (navigator.appName.indexOf(b) != -1);
	if (v == 0) 
		{
		versionOk = true;
		}
	else
		{
		versionOk = (v <= parseInt(navigator.appVersion));
		}
	return browserOk && versionOk;
	}

//-----------------------------------------------------------------------------
// Get the browser type
//-----------------------------------------------------------------------------
var IE4 =  isBrowser('Explorer', 4);
var IE5 =  isBrowser('Explorer', 5);	
var NS6 =  isBrowser('Netscape', 5);
var NS7 = false;
if(NS6)
	NS7 = !navigator.userAgent.match('Netscape6');
var IE = (IE4 || IE5) ? true : false;

var clickFirst = false;

//-----------------------------------------------------------------------------
//
// @NAME
//	clickMenu
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function clickMenu(flag)
	{
	if(flag == 'true')
		clickFirst = true;
	else
		clickFirst = false;
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	isFirst
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------
	
function isFirst()
	{
	if(clickFirst)
		{
		clickFirst = false;
		return true;
		}
	return false;
	}
		
//-----------------------------------------------------------------------------
//
// @NAME
//	getDropdownObjects
//
// @SCOPE
//	
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function getDropdownObjects()
	{
	if(IE)
		{
		if (lengthArray.length <= 0)
			{
			menuLengths = document.all.tags('div');
			for (q=0;q < menuLengths.length;q++)
				{
				thisName = menuLengths[q].id;
				if (thisName.search(/dropdown/) != -1)
					{
					lengthArray = lengthArray.concat(thisName);
					}
				}
			}
		}
	return lengthArray;
	}
//-----------------------------------------------------------------------------
//
// @NAME
//	hideDropdownObjects
//
// @SCOPE
//	 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function hideDropdownObjects(element, mainElm)
	{
	if (IE)
		{
		for (m=0;m<lengthArray.length;m++)
			{
			ddObj = document.all[lengthArray[m]];
			var ddL = ddObj.offsetLeft;
			var ddR = ddObj.clientWidth + ddL;
			var ddT = ddObj.offsetTop;
			var ddB = ddObj.offsetTop + ddObj.clientHeight;
			var mL = element.offsetLeft;
			var mR = element.clientWidth + mL;
			var mT = element.offsetTop;
			var mB = element.offsetTop + element.clientHeight;
			
			if ((ddT<=mB) && !(ddB<mT) && ((ddL>=mL && ddL<=mR)||(mL>=ddL && mL<=ddR)||(ddR>=mL && ddR<=mR)||(ddL<=mL && ddR>=mR)) && (element.style.visibility == 'visible'))
				{
				ddObj.style.visibility = 'hidden';
				}
			else if((ddSwitch != 0) && mainElm)
				{
				var mainMenu = document.all[mainElm];
				var meL = mainMenu.offsetLeft;
				var meR = mainMenu.clientWidth + mL;
				var meT = mainMenu.offsetTop;
				var meB = mainMenu.offsetTop + element.clientHeight;
				if((ddT<=meB) && !(ddB<meT) && ((ddL>=meL && ddL<=meR)||(meL>=ddL && meL<=ddR)||(ddR>=meL && ddR<=meR)||(ddL<=meL && ddR>=meR)) && (mainMenu.style.visibility == 'visible'))
					{
					ddObj.style.visibility = 'hidden';
					}
				} 
			else	
				{
				ddObj.style.visibility = 'visible';
				}
			}
		}
	}

//-----------------------------------------------------------------------------
//
// @NAME
//	showByLink
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	menu show/hide functions
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function showByLink(object,thisDiv,classID)
	{
	if((menu) && (menu != object))
		{
		elm = document.getElementById(menu);
		elm.style.visibility = 'hidden';
		switchOff(menuL,classID);
		}
	menu = object;
	menuL = thisDiv;
	menuStyle = classID;

	elm = document.getElementById(object);
	elmDiv = document.getElementById(thisDiv);
	divWidth = (IE) ? elmDiv.clientWidth : elmDiv.offsetWidth;
	divHeight = (IE) ? elmDiv.clientHeight : elmDiv.offsetHeight;
	
	if(elm.style.visibility == 'visible')
		{
		elm.style.visibility = 'hidden';
		menuHighlight(thisDiv,classID);
		if(IE)
			event.cancelBubble = true;
		getDropdownObjects();
		hideDropdownObjects(elm);
		} 
	else 
		{
		switchOff('all_highlights','menubar');
		hide('all_menus');
		if(onceDone == false)
			{
			menubarFromTop = elm.offsetTop + elmDiv.offsetHeight;
			onceDone = true;
			}
		elm.style.top = menubarFromTop;
		
		if(IE || NS7)
			{
			elm.style.left = elmDiv.offsetParent.offsetLeft;
			}
		else if(NS6)
			{
			elm.style.left = elmDiv.offsetLeft;
			}
			
		elm.style.visibility = 'visible';
		switchOn(thisDiv,classID);
		getDropdownObjects();
		hideDropdownObjects(elm);
		ddSwitch = 1;
		if(IE)
			event.cancelBubble = true;
		}
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	showByMenu
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function showByMenu(object,thisMenu)
	{
	menuLink = thisMenu;
	subMenu = object;
	
	subElm = document.getElementById(object);
	subElmDiv = document.getElementById(thisMenu);
	divWidth = (IE) ? subElmDiv.clientWidth : subElmDiv.offsetWidth;
	divHeight = (IE) ? subElmDiv.clientHeight : subElmDiv.offsetHeight;
	
	subMenuLeft = (IE) ? subElmDiv.offsetParent.offsetParent.offsetParent.offsetLeft : 0;
	subMenuTop = (IE) ? subElmDiv.offsetParent.offsetParent.offsetParent.offsetTop + subElmDiv.offsetParent.offsetTop : 0;
	
	subElm.style.top = (IE) ? subMenuTop : subElmDiv.offsetTop + subMenuTop - 1;
	subElm.style.left = (IE) ? subElmDiv.clientWidth + subMenuLeft : subElmDiv.offsetLeft + subMenuLeft + divWidth -2;	
	
	if(NS7)
		{
		subElm.style.top = subElmDiv.offsetParent.offsetTop + subElmDiv.offsetParent.offsetParent.offsetParent.offsetTop;
		subElm.style.left = subElmDiv.offsetWidth;
		}
			
	subElm.style.visibility = 'visible';

	getDropdownObjects();
	hideDropdownObjects(subElm, menu);
	if(IE)
		{
		event.cancelBubble = true;
		}
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	show
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function show(object) 
	{
	origElm = document.getElementById(object);
	origElm.style.visibility = 'visible';
	getDropdownObjects();
	hideDropdownObjects(origElm);
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	hide
//
// @SCOPE
//	 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function hide(object) 
	{
	if ((object == 'all_menus') && (object))
		{
		menubars = eval(object);
		if (menubars.length > 0)
			{
			for (a=0; a < menubars.length; a++)
				{
				menuElm = document.getElementById(menubars[a]);
	        		menuElm.style.visibility = 'hidden';
				}
			}
		switchOff(menuLink,'menuitem');
		} 
	else if(object)
		{
		origElm = document.getElementById(object);
		origElm.style.visibility = 'hidden';
		}
	
	getDropdownObjects();
	ddSwitch = 0;
	
	if ((lengthArray) && (lengthArray.length > 0) && (IE))
		{
		for (m=0;m<lengthArray.length;m++)
			{
			document.all[lengthArray[m]].style.visibility = 'visible';
			}
		}
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	showSub
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function showSub(object)
	{
	elm = document.getElementById(object);
	elm.style.visibility = 'visible';
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	(
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function hideSub(object) 
	{
	if(object)
		{
		elm = document.getElementById(object);
		elm.style.visibility = 'hidden';
		}
	}

//-----------------------------------------------------------------------------
//
// @NAME
//	
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	show/hide cell style functions for menu Divs
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function switchOn(divID,classID)
	{
	elmStyle = document.getElementById(divID);
	elmStyle.className = (IE) ? classID+"On" : classID+"OnNS";
	}

function switchOff(divID,classID) 
	{
	if ((divID == 'all_highlights') &&(divID))
		{
		highlights = eval(divID);
		if (highlights.length > 0)
			{
			for (a=0; a < highlights.length; a++)
				{
				elmStyle = document.getElementById(highlights[a]);
	        		elmStyle.className = (IE) ? classID+'Off':classID+'OffNS';
				}
			}
		} 
	else if (divID) 
		{
		elmStyle = document.getElementById(divID);
		elmStyle.className = (IE) ? classID+'Off' : classID+'OffNS';
		}
	}
	
//-----------------------------------------------------------------------------
//
// @NAME
//	menuHighlight
//
// @SCOPE
//	function 
//
// @DESCRIPTION
//	
//
// @PARAMETERS
//	@IN
//
//-----------------------------------------------------------------------------

function menuHighlight(object,classID)
	{
	elmStyle = document.getElementById(object);
	elmMenu = document.getElementById(object+'_menu');
	if(elmStyle)
		{
		if((elmStyle.className == classID+'Off') || (elmStyle.className == classID+'OffNS'))
			{
			elmStyle.className = (IE) ? classID+'Highlight' : classID+'HighlightNS';
			}
		else if((elmStyle.className == classID+'On') && (elmMenu.style.visibility == 'hidden'))
			{
			elmStyle.className = (IE) ? classID+'Highlight' : classID+'HighlightNS';
			}
		else if((elmStyle.className == classID+'OnNS') && (elmMenu.style.visibility == 'hidden'))
			{
			elmStyle.className = (IE) ? classID+'Highlight' : classID+'HighlightNS';
			}
		else if((elmStyle.className == classID+'Highlight') || (elmStyle.className == classID+'HighlightNS'))
			{
			elmStyle.className = (IE) ? classID+'Off' : classID+'OffNS';
			}
		}
	}


var menuItemClass = (IE) ? 'menuitemOff' : 'menuitemOffNS';
